<?php

/**
 * @file
 * Front controller for testing the page cache handler.
 */

// Detect root directory of the Drupal installation.
$__FILE__ = __FILE__;
if ($__FILE__[0] != '/') {
  $__FILE__ = str_replace(DIRECTORY_SEPARATOR, '/', $__FILE__);
}
$drupalroot = preg_replace('#(/(sites|profiles)/([^/]+))?/modules(/.*)?/authcache_builtin/tests/frontcontroller/index.php$#', '', $__FILE__);

if ($drupalroot == $__FILE__) {
  trigger_error('Authcache builtin test front controller: failed to locate Drupal root directory', E_USER_ERROR);
  exit();
}

// Relocate contents of $_SERVER variable to DRUPAL_ROOT by removing path
// components pointing to the authcache front controller.
$preg = '|' . preg_quote(substr($__FILE__, strlen($drupalroot) + 1), '|') . '|';
$_SERVER = preg_replace($preg, 'index.php', $_SERVER);

// Change working directory and define the essential DRUPAL_ROOT constant.
chdir($drupalroot);
define('DRUPAL_ROOT', $drupalroot);
require_once DRUPAL_ROOT . '/includes/bootstrap.inc';

// Make sure this file can only be used by simpletest.
drupal_bootstrap(DRUPAL_BOOTSTRAP_CONFIGURATION);
if (!drupal_valid_test_ua()) {
  header($_SERVER['SERVER_PROTOCOL'] . ' 403 Forbidden');
  exit;
}

// Inject conf-variables for testing.
global $conf;
if (!empty($_SERVER['HTTP_X_AUTHCACHE_BUILTIN_TEST_CACHE_BACKEND'])) {
  $module_root = dirname(dirname(dirname($__FILE__)));
  $module_path = substr($module_root, strlen($drupalroot) + 1);
  $conf['cache_backends'][] = $module_path . '/authcache_builtin.cache.inc';
}

drupal_bootstrap(DRUPAL_BOOTSTRAP_FULL);
menu_execute_active_handler();
