<?php
/**
 * @file
 * Defines authcache personalization request registry interface.
 */

/**
 * Registry class for authcache personalization requests.
 */
interface AuthcacheP13nRequestRegistryInterface {
  /**
   * Return a map (path -> request-id).
   */
  public function routes();

  /**
   * Given a path return an appropriate request id.
   */
  public function resolve($path);

  /**
   * Return the configuration for the given request.
   */
  public function get($request_id);

  /**
   * Rebuild info structure for requests.
   */
  public function rebuild();
}
