<?php
/**
 * @file
 * Stub classes for testing.
 */

/**
 * Stub registry.
 */
class AuthcacheP13nTestRequestRegistryStub implements AuthcacheP13nRequestRegistryInterface {
  /**
   * {@inheritdoc}
   */
  public function routes() {
  }

  /**
   * {@inheritdoc}
   */
  public function resolve($path) {
    switch ($path) {
      case 'test/path':
        return 'test/good';

      case 'test/bad':
        return 'test/bad';

      default:
        throw new AuthcacheP13nRequestNotFound();
    }
  }

  /**
   * {@inheritdoc}
   */
  public function get($request_id) {
    switch ($request_id) {
      case 'test/good':
        return new AuthcacheP13nTestRequestHandlerStub();

      case 'test/bad':
        return new AuthcacheP13nTestRequestHandlerBadStub();

      default:
        throw new AuthcacheP13nRequestInvalidInput();
    }
  }

  /**
   * {@inheritdoc}
   */
  public function rebuild() {
  }
}

/**
 * Stub request handler.
 */
class AuthcacheP13nTestRequestHandlerStub implements AuthcacheP13nRequestHandlerInterface {
  /**
   * {@inheritdoc}
   */
  public function handle($params) {
    print serialize($params);
  }

  /**
   * {@inheritdoc}
   */
  public function defaults() {
    return array(
      'd' => 'test-defaults',
    );
  }
}

/**
 * Stub request handler.
 */
class AuthcacheP13nTestRequestHandlerBadStub implements AuthcacheP13nRequestHandlerInterface {
  /**
   * {@inheritdoc}
   */
  public function handle($params) {
    print 'this line is expected to be discarded';
    switch ($params['error']) {
      case 'not_found':
        throw new AuthcacheP13nRequestNotFound();

      case 'invalid_input':
        throw new AuthcacheP13nRequestInvalidInput();

      case 'access_denied':
        throw new AuthcacheP13nRequestAccessDenied();

      case 'server_error':
        throw new AuthcacheP13nRequestException();

      default:
        throw new Exception();
    }
  }

  /**
   * {@inheritdoc}
   */
  public function defaults() {
    return array();
  }
}
